%prep
# in this section, we remove old builds, untar the new sources and
# optionally make some patch. in our case, it only contains %setup
# which untar the sources
%setup -q

%build
# compile executable
	./configure --enable-rpm-maintainer-mode
	make -s ROOT="$RPM_BUILD_ROOT"

%install
	./configure --enable-rpm-maintainer-mode
	make -s ROOT="$RPM_BUILD_ROOT" install

%pre
# pre-install script

%post
# post-install script
echo "Now you need to configure the driver. Please read the README"
echo "and INSTALL files located in /usr/local/doc/eciadsl."

%preun
# pre-uninstall script

%postun
# post-uninstall script

%files
# here, we list all the files that form the binary package.
# executable files should be : rwxr-xr-x
%defattr(755,root,root)
%dir /usr/local/bin
/usr/local/bin/startmodem
/usr/local/bin/eci-load1
/usr/local/bin/eci-load2
/usr/local/bin/pppoeci
/usr/local/bin/eci-doctor.sh
/usr/local/bin/check-hdlc
/usr/local/bin/check-hdlc-bug
/usr/local/bin/eciconf.sh
/usr/local/bin/eciconftxt.sh
/usr/local/bin/remove_dabusb
/usr/local/bin/probe_synch.sh
/usr/local/bin/probe_device.sh
/usr/local/bin/eci_vendor_device.pl
/usr/local/bin/eci_data.pl
/usr/local/bin/eci_uc.pl
/usr/local/bin/makeconfig
# config files should be : rw-r--r--
%defattr(644,root,root)
%dir /etc/eciadsl
%config /etc/ZyXEL/modems.db
%config /etc/ZyXEL/providers.db
%config /etc/ZyXEL/firmware00.bin
%config /etc/ZyXEL/synch01.bin
%config /etc/ZyXEL/modemeci.gif
# doc files should be : rw-r--r--
%defattr(644,root,root)


%clean
# in this section, we clean up temporary files generated during the build
	rm -rf %buildroot

%changelog
- made 0.7-ready.
- Allow non-root users to generate .rpm (removed the use of system rpm topdir).
- Re-introduced ROOT for make invocation (fixes wrong relocation dir).
- Updated for 0.3
- Make a new spec file for 0.5. This spec file is in the CVS.
- Initial spec, from CVS sources (usermode and doc modules)
